/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-07 17:46
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============

ll N;
vector<int> prefix;

int interval(int l, int r){
    if(l == 1) return prefix[r - 1];
    return prefix[r - 1] ^ prefix[l - 2];
}

void solve(){
    // Code goes here ...
    cin >> N;

    vector<int> nums(N);
    R(i, N) cin >> nums[i];

    string s;
    cin >> s;

    prefix = vector<int>(N);

    int sum = 0, onsum = 0;
    R(i, N){
        sum ^= nums[i];
        prefix[i] = sum;
        if(s[i] == '1')
            onsum ^= nums[i];
    }

    int Q;
    cin >> Q;

    int mode;
    int l, r;
    int x;
    R(i, Q){
        cin >> mode;
        if(mode == 1){
            cin >> l >> r;
            onsum ^= interval(l, r);
        }
        else{
            cin >> x;
            cout << (x ? onsum : (sum ^ onsum)) << " ";
        }
    }
    cout << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
